(* This file is part of our reusable OCaml BRICKS library
   Copyright (C) 2009  Jean-Vincent Loddo

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. *)

type action = unit lazy_t
val register : ?ignore_errors:bool -> action -> unit
val exit     : ?ignore_errors:bool -> int -> 'a
val work     : ?ignore_errors:bool -> unit -> unit

module Make :
  functor (Defaults : sig val ignore_errors : bool  val work_at_exit : bool end) ->
    sig
      val register     : ?ignore_errors:bool -> action -> unit
      val work         : ?ignore_errors:bool -> unit -> unit
    end
